#include <iostream>
#include <fstream>
#include <vector>
#include <utility>
#include <vector>
#include <cmath>
#include <algorithm>

#define dreapta first
#define stanga second

#define VALMAX 1000010
#define NMAX 100010

using namespace std;

ifstream f("suma.in");
ofstream g("suma.out");

int n, s, m;
int a[NMAX], fr[VALMAX];

vector<pair<pair<int, int>, int > > bucket[NMAX];
vector<pair<int, long long> > query_resp;

void citeste() {
	f >> n >> s;
	for (int i = 1; i <= n; ++i) {
		f >> a[i];
	}
}

void print_bucket() {
	int rad = sqrt(n);
	int lim = n / rad;
	for (int i = 0; i <= lim; ++i) {
		cout << i << " " << bucket[i].size() << "\n";
		if (bucket[i].size() > 0) {
			for (vector<pair<pair<int, int>, int > > :: iterator it = bucket[i].begin(); it!=bucket[i].end(); ++it) {
				cout <<"(" << (*it).first.stanga << " " << (*it).first.dreapta <<") ";
			}
			cout << "\n";
		}
	}
}

void construct_buckets() {
	unsigned int st, dr, rad;
	f >> m;
	rad = sqrt(n);
	for (int i = 0; i < m; ++i) {
		f >> st >> dr;
		bucket[st / rad].push_back(make_pair(make_pair(dr, st), i));
	}
}

long long init_freq(const int st, const int dr) {
	long long solutions = 0;
	for (int i = st; i <= dr; ++i) {
		if ( s - a[i] >= 0 ) {
			solutions += fr[s - a[i]];
		}
		++fr[a[i]];
	}
	return solutions;
}

void solve_bucket(vector<pair<pair<int, int>, int > > &bucket) {
	vector<pair<pair<int, int>, int> > :: iterator it = bucket.begin();	
	int st = (*it).first.stanga;
	int dr = (*it).first.dreapta;
	long long solutions = init_freq((*it).first.stanga, (*it).first.dreapta);
	query_resp.push_back(make_pair((*it).second, solutions));

	++it;
	for (; it != bucket.end(); ++it) {
		int st_cr = (*it).first.stanga;
		int dr_cr = (*it).first.dreapta;
		long long cr_sol = solutions;
		while (st_cr < st) {
			--st;
			if (s - a[st] >= 0) {
				cr_sol += fr[s - a[st]];
			}
			++fr[a[st]];
		}

		while (st < st_cr) {
			--fr[a[st]];
			if (s - a[st] >= 0) {
				cr_sol -= fr[s - a[st]];
			}
			++st;
		}

		while (dr < dr_cr) {
			++dr;
			if (s - a[dr] >= 0) {
				cr_sol += fr[s - a[dr]];
			}
			++fr[a[dr]];
		}

		solutions = cr_sol;
		query_resp.push_back(make_pair((*it).second, solutions));
	}

	for (int i = st; i <= dr; ++i) {
		--fr[a[i]];
	}
}

void solution() {
	int rad = sqrt(n);
	int lim = n / rad;
	for (int i = 0; i <= lim; ++i) {
		if (bucket[i].size() > 0) {
			sort(bucket[i].begin(), bucket[i].end());
			solve_bucket(bucket[i]);
		}
	}
	sort(query_resp.begin(), query_resp.end());
}

void write() {
	for (std::vector<pair<int, long long> > :: iterator it = query_resp.begin(); it != query_resp.end(); ++it) {
		g <<(*it).second << "\n";
	}
}

int main() {
	citeste();

	construct_buckets();


	solution();

	write();

	f.close();
	g.close();
	return 0;
}
